C HCTEST.FOR
C FL /c /Zi /Od /4Ns /Fs%1.LST %1.FOR
C link /E hctest+hershy,hctest,nul,\msfort\graflib;
$LARGE
C----------------------------------------------------------------------
	PROGRAM HCTEST
	REAL*4		XMIN, XMAX, YMIN, YMAX
	INTEGER*2	MINX, MAXX, MINY, MAXY

	INTEGER*2	GMODE, IERR, COLOR
	CHARACTER	TEXT1*20, TEXT2*20,TEXT3*20, TEXT4*20, FONT*3

	MINX = 0
	MINY = 0
	MAXX = 639
	MAXY = 349

	XMIN = 0.
	XMAX = 115.
	YMIN = 0.
	YMAX = 110.

	GMODE = 24
	COLOR = 7
	
	TEXT1 = ' !$& ()*+,-./0123456'
	TEXT2 = '789:;=?@ABCDEFGHIJKL'
	TEXT3 = 'MNOPQRSTUVWXYZabcdef'
	TEXT4 = 'ghijklmnopqrstuvwxyz'
	CALL HCINIT (10)


 10	CALL SETTXT
	WRITE (*, *) ' Hershey Character Set Demonstration '
	WRITE (*, *) 
	WRITE (*, *) ' Hershey Characters are grouped into 33 fonts. '
	WRITE (*, *) ' The Fonts are numbered from 0 to 32 inclusive.'
	WRITE (*, *)
	WRITE (*, *) ' Enter the number of the font to be displayed, '
	WRITE (*, *) '  or enter -1 to exit this program. '

	WRITE (*, *)
	WRITE (*, *) ' Font Number? '
	READ  (*, *) IFONT
	IF (IFONT .LT. 0) THEN
	   STOP
	ELSEIF (IFONT .GT. 32) THEN
           GOTO 10
	ENDIF 
	WRITE (FONT,'(I2)') IFONT 	
	CALL ZSETUP (GMODE, IERR)
	CALL ZLOCAT (MINX, MAXX, MINY, MAXY)
	CALL ZSCALE (XMIN, XMAX, YMIN, YMAX)
	CALL ZCOLOR (COLOR)
	CALL HCSIZE (5.0)
	CALL HCFONT(IFONT)
	CALL ZMOVE (55.0,100.0)
	CALL ZLABEL ('Hershey Font '//font//'\')
	DO 15 I = 1, 20
           X = (I-.5)*5.0+5.0
	   CALL ZMOVE (X, 90.0)
	   CALL ZLABEL (' '//TEXT1(I:I)//'\')
	   CALL ZMOVE (X, 80.0)
	   CALL HCOUT (TEXT1(I:I),1)

	   CALL ZMOVE (X, 70.0)
	   CALL ZLABEL (' '//TEXT2(I:I)//'\')
	   CALL ZMOVE (X, 60.0)
	   CALL HCOUT (TEXT2(I:I),1)

	   CALL ZMOVE (X, 50.0)
	   CALL ZLABEL (' '//TEXT3(I:I)//'\')
	   CALL ZMOVE (X, 40.0)
	   CALL HCOUT (TEXT3(I:I),1)

	   CALL ZMOVE (X, 30.0)
	   CALL ZLABEL (' '//TEXT4(I:I)//'\')
	   CALL ZMOVE (X, 20.0)
	   CALL HCOUT (TEXT4(I:I),1)
 15	CONTINUE
	CALL ZMOVE (55.0, 5.0)
	CALL ZLABEL (' Press <Q> to quit, <P> to print \')
 	CALL GRWAIT
	GOTO 10
	END

C----------------------------------------------------------------------
	SUBROUTINE GRWAIT
	CHARACTER CH*1
	INTEGER*2 ASCII

 20	CALL INKEY (CH, ASCII)
	IF (CH .EQ. 'P' .OR. CH .EQ. 'p') THEN
	   CALL PGRAPH
	ELSEIF (CH .EQ. 'q' .OR. CH .EQ. 'Q') THEN
	   RETURN
	ELSE
	   GOTO 20
	ENDIF
	END

	
