#include <X11/Xlib.h>
  
  Display *theDisplay;
XFontStruct *initFont(theGC, fontName)
GC theGC;
char fontName[];
{
  Font font;
  XFontStruct *fontStruct;
  fontStruct=XLoadQueryFont(theDisplay,fontName);
  
  if(fontStruct!=0)
    /* 6/26/93
       replaced the following line
       XSetFont(theDisplay,theGC,fontStruct->fid);
       by the Font definition above, and the bracket below:
       */
    {
      font=XLoadFont(theDisplay,fontName);
      XSetFont(theDisplay,theGC,font);
    }
  else
    printf("couldn't set the font %s.\n",fontName);
  
  /* 6/26/93 */
  
  return(fontStruct);
}

/* 6/26/93 */

XFontStruct *releaseFont(theGC, fontName)
GC theGC;
char fontName[];
{
  Font font;
  XFontStruct *fontStruct;
  fontStruct=XLoadQueryFont(theDisplay,fontName);
  if(fontStruct!=0)
    {
      font=XLoadFont(theDisplay,fontName);
      /*
	Xr6, p. 278 of X Window System Programming
      */
      /*
      XUnloadFont(theDisplay,theGC,font);
      */
      XUnloadFont(theDisplay,font);
    }
  else
    printf("Couldn't unset the font %s.\n",fontName);
  return(fontStruct);
}


