#include <curses.h>
#include <math.h>
#include <fcntl.h>

/*
#define reg     register
#define A_UNDERLINE     000000400000L
#define A_REVERSE       000001000000L
#define A_BLINK         000002000000L
#define A_BOLD          000010000000L
#define A_NORMAL        000000000000L
#define A_CHARTEXT      000000177777L 
The fact that the compile says that these are redefined means that you
have the new curses.
*/

int graphics=0;

WINDOW *newwin() ;
WINDOW *WIN ;

int boxxy_()
{
  box (WIN, '|', '-') ;
  return 0;
}

int move_add_char_(nrow,ncol,ch,ch_length)
     int *nrow, *ncol, ch_length;
     char *ch;
{
  int i,j;
  char one, *ptr;

  i = *nrow;
  j = *ncol;
  /* one = ch[0]; */
  /* printf("%s %d %d \n","move_add_char",i,j); */
  wmove(WIN,i,j) ;
  /* printf("%s %s \n","move_add_char",ch); */

  ptr = &ch[0];
  ptr++;
  one = *ptr;
  ptr=NULL;
  system("xmessage -message move_add_char");

  waddch(WIN,ch) ;
  wrefresh(WIN) ;

  *ptr=one;
  return 0;

}

int erase_display_()
{
  werase(WIN);
  wrefresh(WIN) ;
  return 0;
}

int move_the_cursor_(nrow,ncol)
     int *nrow, *ncol;
{
  int i,j;
  i = *nrow;
  j = *ncol;
  /* printf("%s %d %d \n","move_the_cursor",i,j); */
  wmove(WIN,i,j) ;
  return 0;
}

/*
int put_the_characters_(ntype,characters,len_characters)
     int *ntype, len_characters;
     char *characters;
{
  int i,j;
  char buffer[128];
  char one, *ptr;

  i = *ntype;

  if (i == 0) wattrset(WIN, A_NORMAL);
  if (i == 1) wattrset(WIN, A_BOLD);
  if (i == 2) wattrset(WIN, A_REVERSE);
  if (i == 4) wattrset(WIN, A_BLINK);
  if (i == 8) wattrset(WIN, A_UNDERLINE);
  one = characters[len_characters];
  characters[len_characters]=NULL;
  sprintf(buffer,characters);
  characters[len_characters]=one;
  waddstr(WIN,buffer) ;
  wrefresh(WIN) ;
  return 0;

  ptr = &characters[len_characters-1];
  ptr++;
  one = *ptr;
  *ptr=NULL;
  sprintf(buffer,characters);
  waddstr(WIN,buffer) ;
  wrefresh(WIN) ;
  *ptr=one;
  return 0;
}
*/

int put_the_characters_(ntype,characters,len_characters)
     int *ntype, len_characters;
     char *characters;
{
  int i,j;
  char temp[1];

  i = *ntype;
  if (i == 0) wattrset(WIN, A_NORMAL);
  if (i == 1) wattrset(WIN, A_BOLD);
  if (i == 2) wattrset(WIN, A_REVERSE);
  if (i == 4) wattrset(WIN, A_BLINK);
  if (i == 8) wattrset(WIN, A_UNDERLINE);

  temp[1] = (char) NULL;
     for(i=0;i<len_characters;i++) 
     {
       temp[0] = characters[i];
       waddstr(WIN,temp);
     }
  wrefresh(WIN) ;
  return 0;
}

int make_a_window_(nrows,ncols)
     int *nrows,*ncols;
{
  int i,j;
  Get_old_tty() ;
  
  initscr () ;
  raw() ;
  crmode() ;
  noecho() ;
  nonl()   ;
  i = *nrows;
  j = *ncols;
  Get_new_tty() ;
  
  /*         newwin(NROWS, NCOLS, BEGROW, BEGCOL) ; 
  WIN  = newwin( nrows, ncols,  0, 0) ;
  box (WIN, '|', '-') ;
*/
  WIN  = newwin( i, j,  0, 0) ;
  werase (WIN) ;
  wrefresh(WIN) ;
  return 0;
}

int remove_a_window_()
{
  clear() ;
  refresh() ;
  mvcur(0, 0, 0, 0) ;
  endwin() ;
  return 0;
}


void warn_getthekey_()
{
  graphics=1;
}

void getthekey_(keynum)
     int  *keynum;
{
  int cur_char, cbuf;

/*
  setblock_(0,1);
*/
  if (!graphics) 
    {
      cur_char = getchar() & 0177;
      *keynum = cur_char;
    }
  else
    {
      getkey_(keynum);
      cur_char = *keynum;
      if (cur_char == 10) *keynum = 13;
      else if (cur_char == 16) *keynum = 127;
      else if (cur_char == 1200) *keynum = 277;
      else if (cur_char == 1210) *keynum = 274;
      else if (cur_char == 2002) *keynum = 2002;
      else if (cur_char == 880) *keynum = 276;
      else if (cur_char == 890) *keynum = 275;
      else if (cur_char == 401 || cur_char == 402 || cur_char == 403 || cur_char == 404) *keynum = cur_char;
      else if (cur_char > 126) *keynum = 666;
    }
}
/* getthekey */
 
int scroll_down_()
{
  scroll(WIN);
}


sys_(label,str_len)
char *label;
int str_len;
{
  char *ptr, tmp;
  for( ptr=&label[str_len-1]; *ptr == ' '; ptr--);
  ptr++;
  if (ptr > label)
    {
      tmp = *ptr;
      ptr = NULL;
      system(label);
      ptr = &tmp;
    }
}



randomize_(x)
/* returns random numbers between -1 and 1 */
     float *x;
{
  double drand48();
  *x = ((float) drand48() -.5)*2.0;
}
 
int_seed_(i)
     int *i;
{
  long seedval;
  seedval = 178587 + *i * 2;
  srand48(seedval);
}


