C----------------------------------------------------------------------
C ***	Setfmt - return format and width for axis labels

	SUBROUTINE Setfmt2 (Max, Fmt, Width)
	REAL*4		Max
cclong	REAL*8 		Dx
	REAL*4 		Dx
cc
	CHARACTER 	Fmt *(*), Scratch*15
	INTEGER*4  	Width, Ndig, MaxDig
	
	Ndig = 1
	IF (Min .GE. Max) THEN
	  WRITE (Fmt, 100, ERR = 999) Width, Ndig
	  GO TO 20
	ENDIF

      	MaxDig  = Width - 3
	Dx 	= Max + 0.05 / (10 ** MaxDig)

	WRITE (Fmt, 100) Width, MaxDig
cc	WRITE (Scratch, Fmt,) Dx
	WRITE (Scratch, Fmt, ERR = 999) Dx

	Ndig = Width
  10	IF (Scratch (Ndig:Ndig) .EQ. '0') THEN
	  Ndig = Ndig - 1
	  IF (Ndig .GT. 3) GO TO 10
	ENDIF
	Ndig = Ndig - 3
	WRITE (Fmt, 100) Width, Ndig

  20	IF (Scratch (1:1) .EQ. '*') THEN
 999	  IF (Width .GE. 5) THEN
  	    WRITE (Fmt, 200) Width, Width-5
          ELSE
  	    WRITE (Fmt, 200) Width, 0
          ENDIF
	ENDIF 
	
 100	FORMAT ('(F',I2,'.',I2,')')
 200	FORMAT ('(G',I2,'.',I2,')')

	RETURN
	END


