cc..$LARGE
C Examine.for - subroutine to display scrolling results list for VARIO
C
C---------------------------------------------------------------------
	SUBROUTINE Examine (LagNum)

	IMPLICIT INTEGER*4 (A-Z)

	include 'vario.dec'

	CHARACTER	Message*72, Ch*1
cclong
	CHARACTER	Massage*72
	INTEGER*4	key
cc
	INTEGER*4	Scan, Ascii
	INTEGER*4	TopRec, BottomRec, Row1, Row2
	INTEGER*4	FirstRec, LastRec, NumPressed

	DATA    Row1 /3/,    Row2 /18/
	DATA Column1 /1/, Column2 /78/

C Initialize
        Massage ='    Use <q>uit, <f>orward, <r>everse,'
     +       //' <n>ext screen, <p>revious screen,'
	Message = 
     +'<t>op, <b>ottom, or <1> to <9> for movement by tenths of pairs.'
	LastRec = Pairs (LagNum)
	IF (LastRec .EQ. 0) RETURN

	IF (LastRec .LT. 16) THEN
	  TopRec 	= 1
	  BottomRec	= LastRec
	  CALL Put Escreen (TopRec, BottomRec)
	  CALL Flash (20, 2, 'Press any key to exit ')
	  RETURN
	ENDIF

	TopRec 		= LastRec - 15
	BottomRec 	= TopRec + 15
	CALL Put Escreen (TopRec, BottomRec)

 	CALL PutStr (Massage, 72, 20, 2, 2)
 	CALL PutStr (Message, 72, 22, 2, 2)

   20   call getthekey (key)
	Ch = CHAR (key)
 	IF (ch .EQ. 'q' .OR. ch .EQ. 'Q') RETURN

	IF     (ch .EQ. 'f') THEN
ccc
	   IF (BottomRec .LT. LastRec) THEN
	      BottomRec = BottomRec + 1
	      TopRec 	= BottomRec - 15
              CALL Put Escreen (TopRec, BottomRec)
	   ENDIF
ccc	   IF (BottomRec .LT. LastRec) THEN
ccc	      BottomRec = BottomRec + 1
ccc	      TopRec	= TopRec + 1 
ccccc the addition of the +1 and +2 bits to the following lines was a bit of
ccccc trial and error.  Long  .  Ditto below.
ccccc	      CALL Scroll Window (-1, Row1, Column1, Row2, Column2)
ccc	      CALL Scroll Window (-1, Row1+1, Column1,
ccc     * Row2+2, Column2)
ccc
ccc	      CALL Put ERecord (BottomRec, Row2)
ccc	   ENDIF	   

	ELSEIF (ch .EQ. 'r') THEN
	   IF (TopRec .GT. 1) THEN
	      TopRec	= TopRec -1
ccc
	      BottomRec = TopRec + 15
              CALL Put Escreen (TopRec, BottomRec)
ccc
ccc	      BottomRec = BottomRec -1
ccccc begin ditto section!
ccccc	      CALL Scroll Window (1, Row1, Column1, Row2, Column2)
ccc	      CALL Scroll Window (1, Row1+1, Column1,
ccc     * Row2+2, Column2)
ccccc
ccc	      CALL Put ERecord (TopRec, Row1)
	   ENDIF	   

	ELSE IF (ch .EQ. 't') THEN
	   IF (TopRec .NE. 1) THEN
	      TopRec 	= 1
	      BottomRec = TopRec + 15
	      CALL Put Escreen (TopRec, BottomRec)
	   ENDIF	

	ELSEIF (ch .EQ. 'b') THEN
	   IF (BottomRec .LT. LastRec) THEN
	      TopRec 	= LastRec - 15
	      BottomRec = TopRec + 15
	      CALL Put Escreen (TopRec, BottomRec)
	   ENDIF

	ELSEIF (ch .EQ. 'n') THEN
	   IF (BottomRec + 16 .LT. LastRec) THEN
	      TopRec 	= TopRec + 16
	      BottomRec = TopRec + 15
	   ELSE
	      TopRec 	= LastRec - 15
	      BottomRec = TopRec + 15
	   ENDIF
	   CALL Put Escreen (TopRec, BottomRec)

	ELSEIF (ch .EQ. 'p') THEN
	   IF (TopRec - 16 .GE. 1) THEN
	      TopRec 	= TopRec - 16
	      BottomRec = TopRec + 15
	   ELSE
	      TopRec 	= 1
	      BottomRec = TopRec + 15
	   ENDIF
	   CALL Put Escreen (TopRec, BottomRec)

	ELSEIF (Ch .GE. '1' .AND. Ch .LE. '9') THEN
	   NumPressed = ICHAR (Ch) - ICHAR ('0')
	   Krec = (LastRec) * NumPressed/10
	   IF (Krec + 16 .LT. LastRec) THEN
	      TopRec = Krec
	      BottomRec = TopRec + 15
	      CALL Put Escreen (TopRec, BottomRec)
	   ENDIF	        	   
	ENDIF
	GOTO 20
	END

C----------------------------------------------------------------------
C Put PScreen - Put out examine  screen

	SUBROUTINE Put ESCreen (TopRec, BottomRec) 
	IMPLICIT INTEGER*4 (A-Z)

	DO 10 I = TopRec, BottomRec
	   CALL Put ERecord (I, I - TopRec + 3)
 10	CONTINUE	
	RETURN
 	END	 

C----------------------------------------------------------------------
C Put PRecord - Put out examine line
				
	SUBROUTINE Put ERecord (Rec, Row) 

	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'vario.dec'

	CHARACTER	Scratch*13
	CHARACTER	Ifmt*4, Rfmt*7
	INTEGER*4	Rec, Row, Ptr

	DATA IFmt /'(I5)'/, Rfmt /'(F13.3)'/

	Ptr = DiffPtr (Rec)
	WRITE (Scratch (1:7),22) From (Ptr), To (Ptr)
 22	FORMAT (I3,':',I3)
	CALL PutStr (Scratch,  7, Row,  2, 0)

	WRITE (Scratch, Rfmt) Data (From (Ptr))
	CALL PutStr (Scratch, 13, Row,  9, 0)

	WRITE (Scratch, Rfmt) Data (To (Ptr))
	CALL PutStr (Scratch, 13, Row, 22, 0)

	WRITE (Scratch, Rfmt) Distance (Ptr)
	CALL PutStr (Scratch, 13, Row, 36, 0)

	WRITE (Scratch, Rfmt) Direct (Ptr)
	CALL PutStr (Scratch, 13, Row, 50, 0)

	WRITE (Scratch, Rfmt) Difference (Rec)
	CALL PutStr (Scratch, 13, Row, 64, 0)
	RETURN
	END


