$LARGE
        PROGRAM CONTOUR

      COMMON /CONRE1/ IOFFP      ,SPVAL
      COMMON /CONRE4/ SIZEL      ,SIZEM      ,SIZEP      ,NREP       ,
     1                NCRT       ,ILAB       ,NULBLL     ,IOFFD      ,
     2                EXT        ,IOFFM      ,ISOLID     ,NLA        ,
     3                NLM        ,XLT        ,YBT        ,SIDE

	CHARACTER	Name*80, Answer*1, Title*80
	CHARACTER*10	Vname(20), Units(20)
	CHARACTER	Dummy*80
	LOGICAL*1	Fexist
	DIMENSION	Z (50, 50),  S (50, 50), X (50), Y (50)
	DIMENSION	DataRec (20)

      	DATA IX/405/, IY/1000/  

C Initialize Variables
	Ndata  		= 0
	NxGrid 		= 0
	NyGrid 		= 0
	DeltaX 		= 0.0
	DeltaY 		= 0.0
	SPVAL		= 1.E31
	IOFFP		= 1

	DO 10 I = 1, 50
	   DO 10 J = 1, 50
	      Z (I, J) = SPVAL
 10	CONTINUE


	WRITE (*, *) ' Program CONTOUR '
	WRITE (*, *) 
 15	WRITE (*, *) ' Enter Data File Name: '
	READ (5, '(A)') Name
	INQUIRE	(FILE = Name, EXIST = Fexist)
	IF (.NOT. Fexist) THEN
	   WRITE (*,*) ' No Such File found ...'
	   WRITE (*,*) ' Do you want to quit? <Y/N> '
	   READ (5,'(A)') Answer
	   IF (Answer.EQ.'Y' .or. Answer.EQ.'y')THEN
	      STOP
	   ELSE
	      WRITE (*, *) 
	      GOTO 15
	   ENDIF
	ENDIF

	OPEN (UNIT = 10, FILE = Name, ERR = 999, STATUS = 'OLD')
	
	READ  (10,'(A70)', END = 999, ERR = 999) Title
	READ (10,*,     END = 999, ERR = 999) Nvar
	DO 16 I = 1, Nvar
	   READ (10,'(2A10)',END = 999, ERR = 999) Vname(i), Units(i)
 16	CONTINUE

	WRITE (*, *) 
	WRITE (*, *) ' Enter # Points in X direction: '
	READ  (*, *)  NxGrid
	WRITE (*, *) ' Enter # Points in Y direction: '
	READ  (*, *)  NyGrid

	WRITE (*, *) 
	WRITE (*, *) ' Reading Grid '
	DO 30 I = 1, NxGrid
	   DO 30 J = 1, NyGrid
              READ (10, *, END = 999, ERR = 999) Tx, Ty, Z(I,J), S(I,J)
 30	CONTINUE

	WRITE (*, *) 
	WRITE (*, *) 'Enter Min, Max, Increment for Estimates '
	READ (*, *) Flo1, Fhi1, Finc1
	WRITE (*, *) 
	WRITE (*, *) 'Enter Min, Max, Increment for Std Deviations '
	READ (*, *) Flo2, Fhi2, Finc2

	WRITE (*, *) 
	WRITE (*, *) 'Stand By ... building plot file '

C generate contour plot
      	OPEN (unit = 8, file = 'meta.dat', form = 'binary', recl=1440)
        CALL PWRIT (IX,IY, Vname(3), 10, 2, 0, 0)                                                CON00101
      	CALL CONREC (Z, 50, NxGrid, NyGrid, flo1, fhi1, finc1, 0, 0, 0)
      	CALL FRAME

        CALL PWRIT (IX,IY, Vname(4), 10, 2, 0, 0)                                                CON00101
      	CALL CONREC (S, 50, NxGrid, NyGrid, flo1, fhi2, finc2, 0, 0, 0)
      	CLOSE (8)
	WRITE (*, *) ' Now you may use MC to view the plot file ...'
      	STOP
	
 999  	WRITE (*, *) ' ERROR Reading file ... Execution terminated '
	CLOSE (10)
	STOP
	END
