C readstruc.for - for geoeas.for
C----------------------------------------------------------------------
	SUBROUTINE Read Structure (Screen File)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	CHARACTER*(*) Screen File
	CHARACTER*150 Line, Blanks*50
	CHARACTER*10  Start
	CHARACTER*4   Command
	INTEGER*4     LENSTR, Klen, Ptr1, Ptr2

C	DATA Debug Screen /.FALSE./

	IF (Debug Screen) WRITE (*, *) 'Structure File = ', Screen File

	Record = ' '

	Screen Fields = 1
	OPEN (UNIT   = Screen Fields,
     +	      FILE   = Screen File,
     +	      STATUS = 'OLD',
     +	      IOSTAT = IO status)

	IF (IO status .NE. 0) THEN
	  WRITE (*, *) 'File ', Screen File, ' Not Found.'
	  RETURN
	ENDIF

	End Screen (0) = 0
	End Label  (0) = 0
	End Frame  (0) = 0
	Pointer = 1
	Current Screen = 1

   5	IF (Get Line (Screen Fields, Line) .NE. 0) GO TO 99

	IF (Line(1:7) .EQ. 'ENDFILE') GO TO 70

	i = End Screen (Current Screen - 1)  + 1
	Begin Screen (Current Screen) = i

	READ (Line, '(1X,A10)', ERR=99, END=99) Start
	IF (Debug Screen) WRITE (*, *) 'Start = *', Start, '*'
	Line = ' '

C----------------------------------------------------------------------
C   READ FIELDS.
C----------------------------------------------------------------------

  10	IF (Line(1:3) .NE. 'END') THEN

	  IF (Get Line (Screen Fields, Line) .NE. 0) GO TO 99

	  IF (Line(1:3) .NE. 'END') THEN
 100	    FORMAT (1X, A10, I4, 1X, 2(I3, 1X), 4(I2, 1X), 8(I3, 1X))
	    READ (Line, 100, ERR=99, END=99)
     +	          SC Field Name (i),
     +	          SC Length     (i),
     +	          SC Row        (i),
     +	          SC Column     (i),
     +	          SC Attribute  (i),
     +	          SC Chosen Attribute (i),
     +	          SC Field Type (i),
     +	             Next,
     +	          SC Carriage Return (i),
     +	          SC Up         (i),
     +	          SC Down       (i),
     +	          SC Left       (i),
     +	          SC Right      (i),
     +	          SC Members    (i),
     +	          SC Position   (i),
     +	          SC Message    (i)

	    IF (Next .EQ. 0) THEN
	      SC Next (i) = .FALSE.
	    ELSE
	      SC Next (i) = .TRUE.
	    ENDIF

	    SC Pointer (i) = Pointer
	    Record (Pointer : Pointer + SC Length (i) - 1) = ' '
	    IF (SC Field Type (i) .EQ. 4) THEN
	        Record (Pointer : Pointer + SC Length (i) - 1) =
     +	           Line (70 : 69 + SC Length (i))
	        IF (Debug Screen)
     +	           WRITE(*,*) '*', Line (70:69+SC Length(i)), '*'
	        Pointer = Pointer + SC Length (i)
	    ENDIF

	    IF (SC Message (i) .NE. 0) THEN
	      IF (Get Line (Screen Fields, Line) .NE. 0) GO TO 99
	      SC M Length (i) = STR Len (Line) - 11
	      SC M Pointer (i) = Pointer
	      DO 30 m = 1, SC Message (i)
	        Record (Pointer : Pointer + SC M Length (i) - 1) =
     +	          Line (12 : 11+ SC M Length (i))
	        Pointer = Pointer + SC M Length (i)
	        IF (m .LT. SC Message (i)) THEN
	          IF (Get Line (Screen Fields, Line) .NE. 0) GO TO 99
	        ENDIF
  30	      CONTINUE
	    ENDIF

	    i = i + 1
	  ENDIF
	  IF (Debug Screen) THEN
	    WRITE (*, *) 'After processing , Pointer = ', Pointer
	  ENDIF

	  GO TO 10
	ENDIF

	End Screen (Current Screen) = i - 1

	IF (Debug Screen) WRITE (*, *) 'Number of Input Fields = ',
     +	    End Screen (Current Screen)

	Starting Field (Current Screen) = Fld Index (Start)
	IF (Starting Field (Current Screen) .EQ. 0) THEN
	  IF (Debug Screen) THEN
	    WRITE (*, *) 'Starting Field Not Found! = *', Start, '*'
	  ENDIF
	  Starting Field (Current Screen) = 1
	ENDIF

	i = End Label (Current Screen - 1) + 1
	Begin Label (Current Screen) = i
	IF (Debug Screen) WRITE (*, *) 'Begin Label ', i
	Line = ' '

C----------------------------------------------------------------------
C   READ LABELS.
C----------------------------------------------------------------------

  40	IF (Line(1:3) .NE. 'END') THEN

	  IF (Get Line (Screen Fields, Line) .NE. 0) GO TO 99
	  IF (Line(1:3) .NE. 'END') THEN
 120	    FORMAT (I4, 2X, 2(I2, 2X))
	    READ (Line, 120, ERR=99, END=99)
     +	          LB Row (i),
     +	          LB Column (i),
     +	          LB Attribute (i)

	    Length = STR Len (Line) - 13

	    Record (Pointer : Pointer+Length-1) = Line (14:13+Length)
	    LB Pointer (i) = Pointer
	    LB Length  (i) = Length

	    Pointer = Pointer + Length

	    i = i + 1
	  ENDIF
	  GO TO 40
	ENDIF

	End Label (Current Screen) = i - 1

	i = End Frame (Current Screen - 1) + 1
	Begin Frame (Current Screen) = i
	IF (Debug Screen) WRITE (*, *) 'Begin Frame ', i
	Line = ' '

C----------------------------------------------------------------------
C   READ FRAMES.
C----------------------------------------------------------------------

  50	IF (Line(1:3) .NE. 'END') THEN

	  IF (Get Line (Screen Fields, Line) .NE. 0) GO TO 99

	  IF (Line(1:3) .NE. 'END') THEN
 130	    FORMAT (A4, 1X, I1, 5(1X, I3))
	    READ (Line, 130, ERR=99, END=99)
     +	          Command,
     +	          FR Type (i),
     +	          FR Row1 (i),
     +	          FR Column1 (i),
     +	          FR Row2 (i),
     +	          FR Column2 (i),
     +	          FR Attribute (i)

	    IF (Debug Screen)
     +	      WRITE (*, *) 'Command = *', Command, '*', ' i = ', i

	    IF (Command .EQ. 'BOX') THEN
	      IF (FR Row1 (i) .EQ. FR Row2 (i)) THEN
	        FR Command (i) = 1
	      ELSE IF (FR Column1 (i) .EQ. FR Column2 (i)) THEN
	        FR Command (i) = 1
	      ELSE
	        FR Command (i) = 0
	      ENDIF

	    ELSE IF (Command .EQ. 'LINE') THEN
	      FR Command (i) = 1

	    ELSE
	      i = i - 1
	    ENDIF

	    i = i + 1

	  ENDIF

	  GO TO 50
	ENDIF

	End Frame (Current Screen) = i - 1

	Current Screen = Current Screen + 1
	GO TO 5

  70	CLOSE (Screen Fields)

	Total Number of Screens = Current Screen - 1
	Current Screen = 1
	Current Field = Starting Field (Current Screen)
	Next Field = Current Field
	Number of Input Fields = End Screen (Current Screen)
	RETURN

  99	WRITE (*, *) '*** ERROR in SCREEN Definition. Field = ', i
	CLOSE (Screen Fields)
	STOP

	END


