#**********************************************************************
# Screen.mak - MAKE command file for screen library
#**********************************************************************
#
#If the include files change, recompil all modules
SCREENE.LIB:	SCREEN.STR
		COMPIL

SCREEN1.OBJ:	SCREEN1.FOR
		FL  /c /4Ns /4Nt /Od /FPc screen1.for 

SCREEN2.OBJ:	SCREEN2.FOR
		FL  /c /4Ns /4Nt /Od /FPc screen2.for 

LOWLEVEL.OBJ:	LOWLEVEL.FOR
		FL  /c /4Ns /4Nt /Od /FPc lowlevel.for 

ADDED.OBJ:	ADDED.FOR
		FL  /c /4Ns /4Nt /Od /FPc added.for 

KEYCHECK.OBJ:	KEYCHECK.FOR
		FL  /c /4Ns /4Nt /Od /FPc keycheck.for 

ASM\SETMOD.OBJ: ASM\SETMOD.ASM
		MASM ASM\SETMOD,ASM\SETMOD;

ASM\PUTVCH.OBJ: ASM\PUTVCH.ASM
		MASM ASM\PUTVCH,ASM\PUTVCH;

ASM\PUTCUR.OBJ: ASM\PUTCUR.ASM
		MASM ASM\PUTCUR,ASM\PUTCUR;

ASM\SOUND.OBJ:  ASM\SOUND.ASM
		MASM ASM\SOUND,ASM\SOUND;

ASM\GETCHA.OBJ: ASM\GETCHA.ASM
		MASM ASM\GETCHA,ASM\GETCHA;

ASM\GETSHF.OBJ: ASM\GETSHF.ASM
		MASM ASM\GETSHF,ASM\GETSHF;
#
#  One C module is used in the library: Function PutVmem
#  PutVmem does a direct-to-video-memory write to put characters on the
#  screen, which is faster than the using BIOS calls like PUTCUR and PUTVCH
#
# The Object module is in the ASM subdirectory and shouldn't need
# to be recompiled.
#
# If you do not have a Microsoft C compiler, this function can be 
# re-written in FORTRAN to make calls to PUTCUR and PUTVCH;
# See the source code for more information
#
# ASM\PUTVMEM.OBJ:	ASM\PUTVMEM.C
#                       MSC /FPc /c  PUTVMEM; 

SCREENE.LIB:	SCREEN1.OBJ SCREEN2.OBJ LOWLEVEL.OBJ ADDED.OBJ \
		KEYCHECK.OBJ \
                ASM\SETMOD.OBJ ASM\PUTVCH.OBJ ASM\PUTCUR.OBJ \
                ASM\SOUND.OBJ  ASM\GETCHA.OBJ ASM\GETSHF.OBJ \	
 		MAKLIB


