
      subroutine anerr(nfac,jmax,jdim,imax,valpr666,pi666,pj666
     &     , jum,ium,msvar)

c***********************************************************************
c
c          this subroutine computes two types of errors 
c
c***********************************************************************
      implicit real*8 (a-h)
      implicit real*8 (o-z)
      include 'corres.inc'
      real*8 pi666(ium),pj666(jum)
      real*8 valpr666(jum)
c***********************************************************************
c
c          computation of absolute and relative contributions            
c
c***********************************************************************
      do 180 i=1,jmax
         d=0.0
         do 160 j=1,jdim
            d=d+coorj(i,j)*coorj(i,j)
 160     continue
         do 170 j=1,jdim
            c=100.*coorj(i,j)*coorj(i,j)
            crj(i,j)=c/d
            caj(i,j)=pj666(i)*c/valpr666(j+1)  
 170     continue
 180  continue
      do 270 i=1,imax
         d=0.0
         do 250 j=1,jdim
            d=d+coori(i,j)*coori(i,j)
 250     continue
         do 260 j=1,jdim
            c=100.*coori(i,j)*coori(i,j)
            cri(i,j)=c/d
            cai(i,j)=pi666(i)*c/valpr666(j+1)
 260     continue
 270  continue
c***********************************************************************
c
c          analysis of the error of representation
c
c***********************************************************************
      do 361 j=1,jmax
      ccrj(j)=0.
      do 361 i=1,nfac
361   ccrj(j)=ccrj(j)+crj(j,i)
      do 362 i=1,imax
      ccri(i)=0.
      do 362 j=1,nfac
362   ccri(i)=ccri(i)+cri(i,j)
c***********************************************************************
c
c          analysis of the error of reconstruction (ji**2 norm)
c
c***********************************************************************
      nfac1=nfac+1
c      do 370 i=1,imax
c      do 370 j=1,jmax
c      p(i,j)=0.
c      do 370 k=nfac1,jdim
c370   p(i,j)=p(i,j)+faci(i,k)*facj(j,k)*valpr666(k+1)**0.5
c      do 390 i=1,imax
c      pei(i)=0.
c      do 380 j=1,jmax
c380   pei(i)=pei(i)+pj666(j)*p(i,j)*p(i,j)
c390   continue
c      do 410 j=1,jmax
c      pej(j)=0.
c      do 405 i=1,imax
c405   pej(j)=pej(j)+pi666(i)*p(i,j)*p(i,j)
c410   continue
      do 510 j=1,jmax
      pej(j)=0
       do 510 k=nfac1,jdim
510   pej(j)=pej(j)+coorj(j,k)*coorj(j,k)
      do 520 i=1,imax
      pei(i)=0
       do 520 k=nfac1,jdim
520   pei(i)=pei(i)+coori(i,k)*coori(i,k)
      return
      end
