C KrigSubs.f
C--------------------------------------------------------------------------	
C New Screen (Screen number) - sets up a new screen
C
	SUBROUTINE New Screen (Screen Number)
	IMPLICIT INTEGER*4 (A-Z)

        INCLUDE '../common/screen.str'

	PARAMETER (Main Menu Field = 3)
	PARAMETER (Menu Field      = 4)

	CALL Clear Screen
	CALL Set Screen (Screen Number)
	CALL Display Frame
	CALL Display Labels

	DO 10 I = Begin Screen (Current Screen),
     +	         End Screen (Current Screen)
	  IF (SC Field Type (I) .NE. Main Menu Field .AND.
     +	      SC Field Type (I) .NE. Menu Field)
     +	      CALL Write Field (i, SC Attribute (i))

  10	CONTINUE
	
	CALL Erase (20, 2, 76)
	RETURN
	END

C----------------------------------------------------------------------
C Show screen storage
	SUBROUTINE Show Screen Storage

        INCLUDE '../common/screen.str'

	CALL Clear Screen
	K = Total Number of Screens
	J = End Label (K)
	write (*,*) 'Screen Storage Requirements '
	write (*,*)
	write (*,*) '# Screens  :',K                 
	write (*,*) '# Fields   :',End Screen (K)
	write (*,*) '# Labels   :',End Label  (K)
	write (*,*) '# Frames   :',End Frame  (K)
	write (*,*) 'String size:', LB Pointer (J) + LB Length (J) - 1
	write (*,*)
	write (*,*) 'These values must be smaller that those declared'
	write (*,*) 'in ../common/screen.str '
	CALL Flash (20, 2, 'press a key')
	RETURN
	END

C----------------------------------------------------------------------
C Intro Screen - 	displays screen frame/label/fields
C			for the introductory screen

	SUBROUTINE Intro Screen
	IMPLICIT INTEGER*4 (A-Z)
	CALL Clear Screen
	CALL Set Screen (1)
	CALL Display Frame
	CALL Display Labels
cclong	CALL Locate Cursor (25, 0)
	CALL Locate Cursor (23, 0)
cc
	CALL Flash (20, 2, 'Press any key to begin the program ')
	RETURN
	END

C----------------------------------------------------------------------
C Read System Defaults

	SUBROUTINE Read System Defaults
	IMPLICIT INTEGER*4 (A-Z)
 
        INCLUDE 'krige.dec'

	CHARACTER*20  String

cclong	OPEN (UNIT = 10, FILE = 'geoeas.def', STATUS = 'OLD',
	OPEN (UNIT = 10, FILE = 'geoeas.def', STATUS = 'unknown',
     +			 ERR=999)
	READ (10, '(A)', ERR=999,END=999) File Prefix
	READ (10, '(A)', ERR=999,END=999) Data File
	READ (10, '(A)', ERR=999,END=999) String
	Intro = (String (7:8) .EQ. 'ON' .OR.
     +           String (7:8) .EQ. 'on')
	CALL Set Character Value ('FILEPREFIX', File Prefix)
	CLOSE (10)
	RETURN

 999	CLOSE (10)
	INTRO = .TRUE.
	RETURN
	END

C----------------------------------------------------------------------
C Write System Defaults

	SUBROUTINE Write System Defaults
	IMPLICIT INTEGER*4 (A-Z)
 
        INCLUDE 'krige.dec'

	OPEN (UNIT = 10, FILE = 'geoeas.def', STATUS = 'UNKNOWN',
     +			ERR=999)
	WRITE (10, '(A)', ERR = 999) File Prefix
	WRITE (10, '(A)', ERR = 999) Data File
	IF (Intro) THEN
	  WRITE (10, '(A)', ERR = 999) 'INTRO=ON'
	ELSE
	  WRITE (10, '(A)', ERR = 999) 'INTRO=OFF'
	ENDIF
 999	CLOSE (10)
	RETURN
	END



