C DispHist.for Histogram display routines
C----------------------------------------------------------------------
C Examine Histogram - allow scrolling of Histo results on STATS screen
C

	SUBROUTINE Examine Histogram
        IMPLICIT INTEGER*4 (A-Z)

cc	PARAMETER (KEYUP   = 72, KEYDWN   = 80)
cc  	PARAMETER (KEYPGUP = 73, KEYPGDWN = 81)
cc	PARAMETER (KEYEND  = 79, KEYHOME  = 71)
cc	PARAMETER (KEYQUIT = 16, KEYESC   =  1)
cc The use of the getthekey routine obviates the need for these parameters.

           INCLUDE 'stats.dec'

cc        CHARACTER*41	Message
cc
        CHARACTER*72	Message, massage
	character*1	ch
	integer*4  	key
cclong
        CHARACTER*16    Scratch
	INTEGER*4	Scan, Ascii
	INTEGER*4	TopRec, BottomRec, Row1, Row2
	INTEGER*4	FirstRec, LastRec
        INTEGER*4         RecMax

     +                
	DATA    Row1 /9/,    Row2 /18/
	DATA Column1 /1/, Column2 /78/

	massage ='<q>uit, <f>orward, <r>everse,'
     +       //' <n>ext screen, <p>revious screen,'
	message ='<t>op, or <b>ottom: take your pick, pardner.'
C Initialize
	IF (Freq (Nclass+1) .GT. 0) THEN
	   RecMax = Nclass + 1
	ELSE
	   RecMax = Nclass
	ENDIF

	CALL Calc Histogram
   	CALL New Screen (6)
	CALL Display Header

C Put out first 10 records

	TopRec 		= 1
cclong  The line below was replaced (needs real arguments)
cc	BottomRec	=AMIN1 (RecMax, 10)
cc
	BottomRec	=AMIN1 (1.*RecMax, 10.)
	DO 25 I = TopRec, BottomRec
	   CALL Put HRecord (I, I - TopRec + Row1)
 25	CONTINUE	

	IF (RecMax .LE. 10) THEN
	   CALL Flash (20, 2, ' Press any key to quit ...')
	   RETURN
	ENDIF
				
C Scroller

 	CALL PutStr (Massage, 72, 20, 2, 2)
 	CALL PutStr (Message, 72, 22, 2, 2)
20	call getthekey (key)
cc ascii becomes key....
	ch = char(key)
cc replace scan by ch and the appropriate KEYDWN, etc by the assigned letter.
cc
	IF (ch .EQ. 'q' .OR. ch .EQ. 'Q') RETURN

	IF     (ch .EQ. 'f') THEN
	   IF (BottomRec .LT. RecMax) THEN
	      BottomRec = BottomRec + 1
ccc	      TopRec	= TopRec + 1 
              TopRec    = BottomRec - 9
              CALL Put Hscreen (TopRec, BottomRec)
ccc
cc	      CALL Scroll Window (-1, Row1, Column1, Row2, Column2)
ccc	      CALL Scroll Window (-1, Row1+1, Column1,
ccc     +						   Row2+2, Column2)
ccc	      CALL Put HRecord (BottomRec, Row2)
	   ENDIF	   

	ELSEIF (ch .EQ. 'r') THEN
	   IF (TopRec .GT. 1) THEN
	      TopRec	= TopRec -1 
ccc	      BottomRec = BottomRec -1
              BottomRec = TopRec + 9
              CALL Put Hscreen (TopRec, BottomRec)
ccc
cc	      CALL Scroll Window (1, Row1, Column1, Row2, Column2)
ccc	      CALL Scroll Window (1, Row1+1, Column1,
ccc     +						   Row2+2, Column2)
ccc	      CALL Put HRecord (TopRec, Row1)
	   ENDIF	   

	ELSE IF (ch .EQ. 't') THEN
	   IF (TopRec .NE. 1) THEN
	      TopRec 	= 1
	      BottomRec = TopRec + 9
	      CALL Put HSCreen (TopRec, BottomRec) 
	   ENDIF	

	ELSEIF (ch .EQ. 'b') THEN
	   IF (BottomRec .LT. RecMax) THEN
	      TopRec 	= RecMax - 9
	      BottomRec = TopRec + 9
	      CALL Put HSCreen (TopRec, BottomRec) 
	   ENDIF

	ELSEIF (ch .EQ. 'n') THEN
	   IF (BottomRec + 10 .LT. RecMax) THEN
	      TopRec 	= TopRec + 10
	      BottomRec = TopRec + 9
	      CALL Put HSCreen (TopRec, BottomRec) 
	   ELSE
	      TopRec 	= RecMax - 9
	      BottomRec = TopRec + 9
	      CALL Put HSCreen (TopRec, BottomRec) 
	   ENDIF

	ELSEIF (ch .EQ. 'p') THEN
	   IF (TopRec - 10 .GE. 1) THEN
	      TopRec 	= TopRec - 10
	      BottomRec = TopRec + 9
	      CALL Put HSCreen (TopRec, BottomRec) 
	   ELSE
	      TopRec 	= 1
	      BottomRec = TopRec + 9
	      CALL Put HSCreen (TopRec, BottomRec) 
	   ENDIF
	ENDIF
	GOTO 20

	END

C----------------------------------------------------------------------
C Put HScreen - Put out histogram results screen

	SUBROUTINE Put HSCreen (TopRec, BottomRec) 
	IMPLICIT INTEGER*4 (A-Z)
	DO 10 I = TopRec, BottomRec
	   CALL Put HRecord (I, I - TopRec + 9)
 10	CONTINUE	
	RETURN
 	END	 
 		 
C----------------------------------------------------------------------
C Put HRecord - Put out histogram results line

	SUBROUTINE Put HRecord (Rec, Row)

	IMPLICIT INTEGER*4 (A-Z)

           INCLUDE 'stats.dec'

	CHARACTER*13	Scratch
	CHARACTER*4	Ifmt
	CHARACTER*7	Rfmt1, Rfmt2
	INTEGER*4	Rec, Row
	REAL*4		Tcutoff
cclong
	character	blanks*80, bland*13
cc
	DATA Row1 /1/, Row2 /18/, Column1 /1/, Column2 /78/
	DATA IFmt /'(I5)'/, Rfmt1 /'(F7.3)'/, Rfmt2 /'(F13.3)'/
        data blanks( 1:40) /'                                        '/
        data blanks(41:80) /'                                        '/

	bland = '             '
	scratch = bland
	WRITE (Scratch (1:3), '(I3)',ERR = 10) Rec
	CALL PutStr (Scratch,  3, Row,  1, 0)
10	CONTINUE

   	IF (Freq (Rec) .NE. 0) THEN
	scratch = bland
    	   WRITE (Scratch (1:13), Rfmt2, ERR = 20) Cutoff (Rec)
	   CALL PutStr (Scratch, 13, Row,  5, 0)

	scratch = bland
 20	   WRITE (Scratch (1: 5),  Ifmt, ERR = 30) Freq (Rec)
	   CALL PutStr (Scratch,  5, Row, 20, 0)

	scratch = bland
 30	   WRITE (Scratch (1: 13), Rfmt2, ERR = 40) SumWClass (Rec)
	   CALL PutStr (Scratch, 13, Row, 27, 0)

	scratch = bland
 40	   WRITE (Scratch (1: 7),  Rfmt1, ERR = 50) Rfreq (Rec)
	   CALL PutStr (Scratch,  7, Row, 41, 0)

	scratch = bland
 50        WRITE (Scratch (1:13), Rfmt2, ERR = 60) MaxClassV (Rec)
	   CALL PutStr (Scratch, 13, Row, 50, 0)

	scratch = bland
 60	   WRITE (Scratch (1: 13), Rfmt2, ERR = 70) Class Avg (Rec)
	   CALL PutStr (Scratch, 13, Row, 65, 0)

	ELSE
	   call putstr (blanks,72,row, 0,0)
	   CALL PutStr ('         .   ', 13, Row,  5, 0)
	   CALL PutStr ('    .'        ,  5 ,Row, 20, 0)
	   CALL PutStr ('         .   ', 13, Row, 27, 0)
	   CALL PutStr ('   .   '      ,  7, Row, 41, 0)
	   CALL PutStr ('         .   ', 13, Row, 50, 0)
	   CALL PutStr ('         .   ', 13, Row, 65, 0)
	ENDIF 
 70	CONTINUE
	RETURN
	END


