cc   $LARGE
C Percent.for - subroutine to display scrolling percentiles list for STATS
C
C---------------------------------------------------------------------
	SUBROUTINE Percentile

	IMPLICIT INTEGER*4 (A-Z)

cc	PARAMETER (KEYUP   = 72, KEYDWN   = 80)
cc	PARAMETER (KEYPGUP = 73, KEYPGDWN = 81)
cc 	PARAMETER (KEYEND  = 79, KEYHOME  = 71)
cc	PARAMETER (KEYQUIT = 16, KEYESC   =  1)

		INCLUDE 'stats.dec'

cclong character changes in line with prevar changes
	CHARACTER*10	MenuName, Menu Choice
	CHARACTER*72	Message
cclong
	CHARACTER*72	Massage
	integer*4       key
cc
	CHARACTER*16	Scratch 
	CHARACTER*1	Ch
	INTEGER*4	Scan, Ascii
	INTEGER*4	TopRec, BottomRec, Row1, Row2
	INTEGER*4	FirstRec, LastRec, NumPressed
	REAL*4		Temp, Ginv

	DATA Menu Name /'PERCENTILE'/
	DATA    Row1 /3/,    Row2 /18/
	DATA Column1 /1/, Column2 /72/

C Initialize
cc	Message = 
cc     +  'Use  or  to scroll | <1> thru <9> to position | or <Q>uit'
cc
	massage ='   Use <q>uit, <f>orward, <r>everse,'
     +       //' <n>ext screen, <p>revious screen,'
	message =
     +  '<t>op, <b>ottom, <1> to <9> (for movement by tenths of pairs).'
cc
	IF (Nkept .LT. 16) THEN
	  TopRec 	= FirstPtr
	  BottomRec	= TopRec + Nkept - 1
	  CALL Put Pscreen (TopRec, BottomRec)
	  CALL Flash (20, 2, 'Press any key to exit ')
	  RETURN
	ENDIF

	TopRec 		= FirstPtr
	BottomRec	= TopRec + 15
	CALL Put Pscreen (TopRec, BottomRec)

 	CALL PutStr (Massage, 72, 20, 2, 2)
 	CALL PutStr (Message, 72, 22, 2, 2)
20	call getthekey (key)
	ch = char (key)
	IF (ch .EQ. 'q' .OR. ch .EQ. 'Q') RETURN

	IF     (ch .EQ. 'f') THEN
	   IF (BottomRec .LT. LastPtr) THEN
	      BottomRec = BottomRec + 1
ccc	      TopRec	= TopRec + 1 
              TopRec    = BottomRec - 15
              CALL Put Pscreen (TopRec, BottomRec)
ccc
ccc	      TopRec	= TopRec + 1 
cclong	      CALL Scroll Window (-1, Row1, Column1, Row2, Column2)
ccc	      CALL Scroll Window (-1, Row1+1, Column1,
ccc     +                                  Row2+2, Column2)
ccc	      CALL Put PRecord (BottomRec, Row2)
	   ENDIF	   

	ELSEIF (ch .EQ. 'r') THEN
	   IF (TopRec .GT. FirstPtr) THEN
	      TopRec	= TopRec -1 
ccc	      BottomRec = BottomRec -1
              BottomRec = TopRec + 15
              CALL Put Pscreen (TopRec, BottomRec)
ccc
cclong	      CALL Scroll Window (1, Row1, Column1, Row2, Column2)
ccc	      CALL Scroll Window (1, Row1+1, Column1,
ccc     +                                 Row2+2, Column2)
ccc	      CALL Put PRecord (TopRec, Row1)
	   ENDIF	   

	ELSE IF (ch .EQ. 't') THEN
	   IF (TopRec .NE. FirstPtr) THEN
	      TopRec 	= FirstPtr
	      BottomRec = TopRec + 15
	      CALL Put Pscreen (TopRec, BottomRec)
	   ENDIF	

	ELSEIF (ch .EQ. 'b') THEN
	   IF (BottomRec .LT. LastPtr) THEN
	      TopRec 	= LastPtr - 15
	      BottomRec = TopRec + 15
	      CALL Put Pscreen (TopRec, BottomRec)
	   ENDIF

	ELSEIF (ch .EQ. 'n') THEN
	   IF (BottomRec + 16 .LT. LastPtr) THEN
	      TopRec 	= TopRec + 16
	      BottomRec = TopRec + 15
	      CALL Put Pscreen (TopRec, BottomRec)
	   ELSE
	      TopRec 	= LastPtr - 15
	      BottomRec = TopRec + 15
	      CALL Put Pscreen (TopRec, BottomRec)
	   ENDIF

	ELSEIF (ch .EQ. 'p') THEN
	   IF (TopRec - 16 .GE. FirstPtr) THEN
	      TopRec 	= TopRec - 16
	      BottomRec = TopRec + 15
	      CALL Put Pscreen (TopRec, BottomRec)
	   ELSE
	      TopRec 	= FirstPtr
	      BottomRec = TopRec + 15
	      CALL Put Pscreen (TopRec, BottomRec)
	   ENDIF

	ELSEIF (Ch .GE. '1' .AND. Ch .LE. '9') THEN
	   NumPressed = ICHAR (Ch) - ICHAR ('0')
	   Krec = FirstPtr + (LastPtr-FirstPtr) * NumPressed/10
	   IF (Krec + 16 .LT. LastPtr) THEN
	      TopRec = Krec
	      BottomRec = TopRec + 15
	      CALL Put Pscreen (TopRec, BottomRec)
	   ENDIF	        	   
	ENDIF
	GOTO 20

	END
C----------------------------------------------------------------------
C Put PScreen - Put out percentiles screen

	SUBROUTINE Put PSCreen (TopRec, BottomRec) 
	IMPLICIT INTEGER*4 (A-Z)

	DO 10 I = TopRec, BottomRec
	   CALL Put PRecord (I, I - TopRec + 3)
 10	CONTINUE	
	RETURN
 	END	 
C----------------------------------------------------------------------
C Put PRecord - Put out percentiles line
				
	SUBROUTINE Put PRecord (Rec, Row) 

	IMPLICIT INTEGER*4 (A-Z)

		INCLUDE 'stats.dec'

cclong character changes in line with prevar changes
	CHARACTER*14	Scratch, blanks
	CHARACTER*4	Ifmt
	CHARACTER*7	Rfmt1, Rfmt2
	INTEGER*4	Rec, Row, Rank
	REAL*4		Ginv, T

	DATA Row1 /3/, Row2 /18/, Column1 /1/, Column2 /78/
	DATA IFmt /'(I5)'/, Rfmt1 /'(F7.3)'/, Rfmt2 /'(F14.4)'/

	Rank = Rec - FirstPtr + 1
cclong
	blanks = '              '
cc
cclong I introduced this to try to prevent a certain overlap of numbers
	scratch = blanks
cc
	WRITE (Scratch (1:5), Ifmt) Rank
	CALL PutStr (Scratch,  5, Row,  3, 0)

	scratch = blanks
	WRITE (Scratch (1:14), Rfmt2) Data (Rec)
	CALL PutStr (Scratch, 14, Row, 11, 0)

	scratch = blanks
	WRITE (Scratch (1:14), Rfmt2) Weights (Ptr (Rec))
	CALL PutStr (Scratch, 14, Row, 29, 0)

	scratch = blanks
	WRITE (Scratch (1: 7),  Rfmt1) Cpercent (Rec)
	CALL PutStr (Scratch,  7, Row, 47, 0)

	T = Cpercent (Rec)
	IF (T .GT. 0. .AND. T .LT. 1.0) THEN
	   scratch = blanks
	   WRITE (Scratch (1: 7),  Rfmt1) GINV (T)
	   CALL PutStr (Scratch,  7, Row, 57, 0)
	ENDIF

	scratch = blanks
	WRITE (Scratch (1: 5), Ifmt) Ptr (Rec)
	CALL PutStr (Scratch,  5, Row, 67, 0)

	RETURN
	END



